local tourist = LibStub("LibTourist-3.0")
local mapfiles = LibStub("LibMapData-1.0")
local frame = CreateFrame("FRAME", "AutoraidFrame")

local OnUpdateThrottle, partyMembers, e_x, e_y  = 0, 0, 9999, 9999
local zoneRaids = {}

local function Autoraid_IterateZoneRaids()
	zoneRaids = {}
	for instance in tourist:IterateZoneInstances(GetZoneText()) do
		if (tourist:GetInstanceGroupSize(instance) > 5) then
			table.insert(zoneRaids, instance)
		end		
	end
end

local function Autoraid_OnUpdate(self, elapsed)
	OnUpdateThrottle = OnUpdateThrottle + elapsed
	if ((not (ThrottleTimer) or (OnUpdateThrottle >= ThrottleTimer)) and not (UnitInRaid("player")) and (zoneRaids[1]) and (IsPartyLeader())) then
		local ArCoordX, ArCoordY, i_x, i_y = 0, 0, 0, 0
		OnUpdateThrottle = 0
		ArCoordX, ArCoordY = GetPlayerMapPosition("player")
		ArCoordX = ArCoordX*100
		ArCoordY = ArCoordY*100
		for _, instance in ipairs(zoneRaids) do
			_, i_x, i_y = tourist:GetEntrancePortalLocation(instance)
-- 0 after GetCurrentMapAreaID() is the floor number
			if ((mapfiles:Distance(GetCurrentMapAreaID(), 0, ArCoordX, ArCoordY, i_x, i_y) < (mapfiles:Distance(GetCurrentMapAreaID(), 0, ArCoordX, ArCoordY, e_x, e_y)))) then
				e_x = i_x
				e_y = i_y
			end
			if (mapfiles:Distance(GetCurrentMapAreaID(), 0, ArCoordX, ArCoordY, e_x, e_y) < 10000) then
				ThrottleTimer = 0.1
			else
				ThrottleTimer = 2
			end
		end
-- IsFlying temporary convert prevention when flying over until I can figure out how to handle z axis.
		if (not IsFlying() and (mapfiles:Distance(GetCurrentMapAreaID(), 0, ArCoordX, ArCoordY, e_x, e_y) < 500)) then
			partyMembers = GetNumPartyMembers()
			for i = 1, partyMembers do
				if (10 > UnitLevel("party"..i)) then 
					print("Autoraid:", ERR_RAID_DISALLOWED_BY_LEVEL)
				end
			end
			ConvertToRaid()
		end
	end
end

--Fallback if for whatever reason the party doesn't convert. Also update zoneHasRaids on map update.
frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
frame:RegisterEvent("UI_ERROR_MESSAGE")
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("PARTY_LEADER_CHANGED")
local function eventHandler(self, event, ...)
	if ((event == "ZONE_CHANGED_NEW_AREA" or event == "PLAYER_LOGIN" or event == "PARTY_LEADER_CHANGED") and (IsPartyLeader()) and not (UnitInRaid("player"))) then
		Autoraid_IterateZoneRaids()
		if (zoneRaids[1]) then
			frame:SetScript("OnUpdate", Autoraid_OnUpdate)
		end
	elseif ((event == "UI_ERROR_MESSAGE") and ((select(1,...) == ERR_RAID_GROUP_ONLY) and (IsPartyLeader()))) then
		partyMembers = GetNumPartyMembers()
		for i = 1, partyMembers do
			if (10 > UnitLevel("party"..i)) then 
				print("Autoraid:", ERR_RAID_DISALLOWED_BY_LEVEL)
			end
		end
		ConvertToRaid()
		frame:SetScript("OnUpdate", nil)
	else
		frame:SetScript("OnUpdate", nil)
	end
end
frame:SetScript("OnEvent", eventHandler)